#ifndef HCLASS
#define HCLASS

#include "RooAbsPdf.h"
#include "RooRealProxy.h"
#include "RooTrace.h"

class RooRealVar;


class simpleHist : public RooAbsPdf {
public:
    simpleHist() {    } ;
    simpleHist(const char *name, const char *title, RooAbsReal& _x,TH1* _hist) :
        RooAbsPdf(name,title),
        hist(_hist),
        x("x","Observable",this,_x)
    {};
    simpleHist(const simpleHist& other, const char* name=0) :
        RooAbsPdf(other,name),
        hist(other.hist),
        x("x",this,other.x)
    {};
    virtual TObject* clone(const char* newname) const { return new simpleHist(*this,newname); }
    inline virtual ~simpleHist() {  }
    RooRealProxy x ;
    TH1* hist;
protected:
    // Double_t evaluate() const { return x; };
    Double_t evaluate() const {
        int binIndex = hist->FindBin(x);
        double ret   = hist->GetBinContent(binIndex)/hist->GetBinWidth(binIndex);
        cout<<"evaluate called: "<<x<<", "<<ret<<endl;
        return ret;
    };
private:
    ClassDef(simpleHist,1) // Gaussian PDF
};
ClassImp(simpleHist);

#endif
